Subject: Re: Question on DHCP

From: Stephen Hemminger <[email-masked]>
Date: Tue, 12 Oct 2010 18:45:43 -0700

On Tue, 12 Oct 2010 21:33:25 -0400
Sri Ram Vemulpali <[email-masked]> wrote:

> Hi All,
> 
>    I have very basic stupid doubt. Can anyone help to resolve this.
> 
> DHCP, is used for dynamically configuring IP address, mask, MTU, DNS
> domain, .... for a host. DHCP is a application layer protocol, but the
> values it configures are related to IP layer. How come DHCP can
> configure when its data packet in embedded in to IP datagram, which
> are disparate layers. I am little confused. Please clarify. Thanks.
> 

DHCP client uses UDP to send broadcast packet and find the nearest
server.  The Linux DHCP client ends up using a AF_PACKET socket because
it wants to seem MAC address of server.

--